import 'dart:convert';

import 'package:contentsquare/contentsquare.dart';
import 'package:contentsquare/src/obfuscation/keep.dart';
import 'package:flutter/foundation.dart';
import 'package:webview_flutter/platform_interface.dart';

import 'adapters/adapters.dart';

/// The type of event that is sent from the webview.
@a273
enum ContentsquareJavascriptEventEnum {
  /// Send a pageView event or any kind of gesture.
  sendEvent,

  /// Send an exception.
  sendException,

  /// Send a message.
  sendMessage,

  /// Opt in.
  optIn,

  /// Opt out.
  optOut,

  /// Send transaction.
  sendTransaction,

  /// Send dynamic var.
  sendDynamicVar,
}


const _a363 =
    'CSJavascriptBridge_FlutterJavascriptChannel_';


@visibleForTesting
class a149 {
  
  a149({
    required this.a57,
    required this.a56,
    required this.a55,
  });

  
  final Contentsquare a57;

  
  final ContentsquareJavascriptEventEnum a56;

  
  String get _a248 =>
      '$_a363${a56.name}';

  
  final String? Function() a55;

  
  JavascriptChannel get a2 {
    return JavascriptChannel(
      name: _a248,
      onMessageReceived: (message) async {
        return _a249(message);
      },
    );
  }

  
  Future<void> _a249(JavascriptMessage a516) {
    final a364 = jsonDecode(a516.message) as Map<String, dynamic>;
    return _a250(a57).a13(a364);
  }

  a168 _a250(Contentsquare a517) {
    switch (a56) {
      case ContentsquareJavascriptEventEnum.sendEvent:
        return a159(
          a51: a517,
          a50: a55,
        );
      case ContentsquareJavascriptEventEnum.sendException:
        return a165(a47: a517);
      case ContentsquareJavascriptEventEnum.sendMessage:
        return a164(a48: a517);
      case ContentsquareJavascriptEventEnum.optIn:
        return a151(a54: a517);
      case ContentsquareJavascriptEventEnum.optOut:
        return a153(a53: a517);
      case ContentsquareJavascriptEventEnum.sendTransaction:
        return a167(a45: a517);
      case ContentsquareJavascriptEventEnum.sendDynamicVar:
        return a166(a46: a517);
    }
  }

  
  String get a1 => '''
function (${_a250(a57).a0.map((name) => name).join(', ')}) {
  window.$_a248.postMessage(
    JSON.stringify({${_a250(a57).a0.map((name) => '"$name": $name').join(', ')}})
  );
}''';
}
